// 2018 ReVoL Primer Template
// point.h
//  
#define EPS 0.001
//  ""
struct point {
    // 
    double X, Y, Z;
    //   
    point() : X(0), Y(0), Z(0) {}
    //  
    point(double x, double y, double z) : X(x), Y(y), Z(z) {}
    //  
    void set(double x, double y, double z) {
        X = x;
        Y = y;
        Z = z;
    }
    //  
    double length() {
        return sqrt(X * X + Y * Y + Z * Z);
    }
    //     
    point normalize() {
        double m = length();
        if (fabs(m) > EPS) {
            X /= m;
            Y /= m;
            Z /= m;
        }
        return *this;
    }
    //   
    double scalar(point a) {
        return (X * a.X + Y * a.Y + Z * a.Z);
    }
    //  
    point operator - (point a) {
        return point(X - a.X, Y - a.Y, Z - a.Z);
    }
    //    
    point operator * (double a) {
        return point(X * a, Y * a, Z * a);
    }
    //    
    point operator / (double a) {
        if (fabs(a) < EPS) return point(X, Y, Z);
        return point(X / a, Y / a, Z / a);
    }
    //   
    point operator += (point a) {
        X += a.X;
        Y += a.Y;
        Z += a.Z;
        return *this;
    }
    //   
    point operator -= (point a) {
        X -= a.X;
        Y -= a.Y;
        Z -= a.Z;
        return *this;
    }
    //    
    point operator *= (double a) {
        X *= a;
        Y *= a;
        Z *= a;
        return *this;
    }
    //    
    point operator /= (double a) {
        if (fabs(a) < EPS) return point(X, Y, Z);
        X /= a;
        Y /= a;
        Z /= a;
        return *this;
    }
};
//    
typedef point * matrix;
//     
struct triang;
//     
typedef triang * triangs;
#include "triang.h"
