// 2018 ReVoL Primer Template
// render.cpp
#include "render.h"
void ObjectSelect(objects o) {
    object = o;
    Scene();
    InvalidateRect(W1, 0, 0);
}
void RenderSelect(render_method r) {
    render = r;
    Scene();
    InvalidateRect(W1, 0, 0);
}
int GetEditValue(HWND hwnd) {
    GetWindowText(hwnd, buf, MAXED);
    if (strlen(buf) == 0) return 0;
    return atoi(buf);
}
void SetEditValue(HWND hWnd, int value) {
    _itoa(value, buf, 10);
    SetWindowText(hWnd, buf);
}
void SetInitials() {
    loaded = 1;
    WCO = box_matrix_W;
    TRIS = box_triangs;
    MakeBox();
    WCO = cyl_matrix_W;
    TRIS = cyl_triangs;
    MakeCyl();
    WCO = usr_matrix_W;
    TRIS = usr_triangs;
    MakeUser();
    Initials();
    Scene();
    SetEditValue(WX, XAngle);
    SetEditValue(WZ, ZAngle);
    SetEditValue(WP, Plane);
    SetEditValue(WLX, LX);
    SetEditValue(WLY, LY);
    SetEditValue(WLZ, LZ);
    SetEditValue(WKA, (int)(KA * 100));
    SetEditValue(WKD, (int)(KD * 100));
    SetEditValue(WKS, (int)(KS * 100));
    SetEditValue(WPH, (int)PH);
    CheckRadioButton(WR0, RE_GOURA, RE_PHONG, render);
    CheckRadioButton(WJ, BOX, USR, object);
    CheckDlgButton(WR0, ID_BG, blackground);
    SelectBackground(blackground);
    if (drawedges != 0) drawedges = 1;
    CheckDlgButton(WR0, ID_ED, drawedges);
    SetFocus(WX);
    SendMessage(WX, EM_SETSEL, 0, -1);
}
LRESULT CALLBACK GDEProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam) {
    PAINTSTRUCT ps;
    HDC hdc;
    int L, T, W, H;
    switch (msg) {
    case WM_LBUTTONDOWN:
        SetFocus(WX);
        SendMessage(WX, EM_SETSEL, 0, -1);
        return 0;
    case WM_PAINT:
        if (!loaded) return 0;
        PatBlt(CDC, 0, 0, GDSZ+2, GDSZ+2, PATCOPY);
        DrawView(CDC);
        hdc = BeginPaint(hWnd, &ps);
        L = ps.rcPaint.left;
        T = ps.rcPaint.top;
        W = ps.rcPaint.right - L;
        H = ps.rcPaint.bottom - T;
        BitBlt(hdc, L, T, W, H, CDC, L, T, SRCCOPY);
        EndPaint(hWnd, &ps);
        return 0;
    }
    return DefWindowProc(hWnd, msg, wParam, lParam);
}
LRESULT CALLBACK OBProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam) {
    int wmIdent, wmEvent;
    if (msg == WM_COMMAND) {
        wmIdent = LOWORD(wParam);
        wmEvent = HIWORD(wParam);
        if (wmEvent == BN_CLICKED) {
            switch (wmIdent) {
            case BOX: case CYL: case USR:
                focused = 0;
                CheckRadioButton(WJ, BOX, USR, wmIdent);
                ObjectSelect((objects)wmIdent);
                return 0;
            }
        }
        return DefWindowProc(hWnd, msg, wParam, lParam);
    }
    return DefWindowProc(hWnd, msg, wParam, lParam);
}
LRESULT CALLBACK RenderProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam) {
    int wmIdent, wmEvent;
    UINT checked;
    switch (msg) {
    case WM_COMMAND:
        wmIdent = LOWORD(wParam);
        wmEvent = HIWORD(wParam);
        switch (wmIdent) {
        case RE_GOURA: case RE_PHONG:
            if (wmEvent == BN_CLICKED) {
                focused = 0;
                CheckRadioButton(WR0, RE_GOURA, RE_PHONG, wmIdent);
                RenderSelect((render_method)wmIdent);
            }
            return 0;
        case ID_BG:
            switch (wmEvent) {
            case BN_CLICKED:
                focused = 0;
                checked = IsDlgButtonChecked(WR0, ID_BG);
                SelectBackground(checked);
                InvalidateRect(W1, 0, 0);
                return 0;
            }
            break;
        case ID_ED:
            switch (wmEvent) {
            case BN_CLICKED:
                focused = 0;
                drawedges = IsDlgButtonChecked(WR0, ID_ED);
                InvalidateRect(W1, 0, 0);
                return 0;
            }
            break;
        }
        break;
    }
    return DefWindowProc(hWnd, msg, wParam, lParam);
}
LRESULT CALLBACK UCProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam) {
    int wmIdent, wmEvent;
    switch (msg) {
    case WM_COMMAND:
        wmIdent = LOWORD(wParam);
        wmEvent = HIWORD(wParam);
        switch (wmIdent) {
        case ID_AX:
            switch (wmEvent) {
            case EN_CHANGE:
                XAngle = GetEditValue(WX);
                InvalidateRect(W1, 0, 0);
                return 0;
            case EN_SETFOCUS:
                focused = WX;
                SendMessage(WX, EM_SETSEL, 0, -1);
                return 0;
            }
            break;
        case ID_AZ:
            switch (wmEvent) {
            case EN_CHANGE:
                ZAngle = GetEditValue(WZ);
                InvalidateRect(W1, 0, 0);
                return 0;
            case EN_SETFOCUS:
                focused = WZ;
                SendMessage(WZ, EM_SETSEL, 0, -1);
                return 0;
            }
            break;
        case ID_VP:
            switch (wmEvent) {
            case EN_CHANGE:
                Plane = GetEditValue(WP);
                InvalidateRect(W1, 0, 0);
                return 0;
            case EN_SETFOCUS:
                focused = WP;
                SendMessage(WP, EM_SETSEL, 0, -1);
                return 0;
            }
            break;
        case ID_LX:
            switch (wmEvent) {
            case EN_CHANGE:
                LX = GetEditValue(WLX);
                InvalidateRect(W1, 0, 0);
                return 0;
            case EN_SETFOCUS:
                focused = WLX;
                SendMessage(WLX, EM_SETSEL, 0, -1);
                return 0;
            }
            break;
        case ID_LY:
            switch (wmEvent) {
            case EN_CHANGE:
                LY = GetEditValue(WLY);
                InvalidateRect(W1, 0, 0);
                return 0;
            case EN_SETFOCUS:
                focused = WLY;
                SendMessage(WLY, EM_SETSEL, 0, -1);
                return 0;
            }
            break;
        case ID_LZ:
            switch (wmEvent) {
            case EN_CHANGE:
                LZ = GetEditValue(WLZ);
                InvalidateRect(W1, 0, 0);
                return 0;
            case EN_SETFOCUS:
                focused = WLZ;
                SendMessage(WLZ, EM_SETSEL, 0, -1);
                return 0;
            }
            break;
        case ID_KA:
            switch (wmEvent) {
            case EN_CHANGE:
                KA = ((double)GetEditValue(WKA) / 100.0);
                InvalidateRect(W1, 0, 0);
                return 0;
            case EN_SETFOCUS:
                focused = WKA;
                SendMessage(WKA, EM_SETSEL, 0, -1);
                return 0;
            }
            break;
        case ID_KD:
            switch (wmEvent) {
            case EN_CHANGE:
                KD = ((double)GetEditValue(WKD) / 100.0);
                InvalidateRect(W1, 0, 0);
                return 0;
            case EN_SETFOCUS:
                focused = WKD;
                SendMessage(WKD, EM_SETSEL, 0, -1);
                return 0;
            }
            break;
        case ID_KS:
            switch (wmEvent) {
            case EN_CHANGE:
                KS = ((double)GetEditValue(WKS) / 100.0);
                InvalidateRect(W1, 0, 0);
                return 0;
            case EN_SETFOCUS:
                focused = WKS;
                SendMessage(WKS, EM_SETSEL, 0, -1);
                return 0;
            }
            break;
        case ID_PH:
            switch (wmEvent) {
            case EN_CHANGE:
                PH = (double)GetEditValue(WPH);
                InvalidateRect(W1, 0, 0);
                return 0;
            case EN_SETFOCUS:
                focused = WPH;
                SendMessage(WPH, EM_SETSEL, 0, -1);
                return 0;
            }
            break;
        }
        break;
    }
    return DefWindowProc(hWnd, msg, wParam, lParam);
}
LRESULT CALLBACK WndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam) {
    short wheel = 0;
    switch (msg) {
    case WM_MOUSEWHEEL:
        wheel = (short)HIWORD(wParam);
        if (wheel > 0) Plane += WHEEL; else Plane -= WHEEL;
        sprintf(buf, "%d", Plane);
        SetWindowText(WP, buf);
        InvalidateRect(W1, 0, 0);
        return 0;
    case WM_DESTROY:
        DeleteObject(tahoma);
        DeleteObject(PenW);
        DeleteObject(PenB);
        DeleteObject(CBMP);
        DeleteDC(CDC);
        PostQuitMessage(0);
        return 0;
    }
    return DefWindowProc(hWnd, msg, wParam, lParam);
}
ATOM RegisterClasses(HINSTANCE hInstance) {
    WNDCLASSEX wcex;
    wcex.cbSize = sizeof(WNDCLASSEX);
    wcex.lpszClassName = "RENDER";
    wcex.lpfnWndProc = (WNDPROC)WndProc;
    wcex.style = CS_HREDRAW | CS_VREDRAW;
    wcex.cbClsExtra = 0;
    wcex.cbWndExtra = 0;
    wcex.hInstance = hInstance;
    wcex.hIcon = LoadIcon(hInstance, (LPCTSTR)IDI_RENDER);
    wcex.hCursor = LoadCursor(0, IDC_ARROW);
    wcex.hbrBackground = (HBRUSH)(COLOR_WINDOW);
    wcex.lpszMenuName = 0;
    wcex.hIconSm = LoadIcon(hInstance, (LPCTSTR)IDI_SMALL);
    return RegisterClassEx(&wcex);
}
BOOL CreateControls(HINSTANCE hInst, HWND hWnd) {
    int ccy, cy;
    tahoma = CCreateFont(hWnd, "Tahoma", 8);
    W1 = CCreatePaintBox(hInst, hWnd, GWW + 22, UTOP, GDSX, GDSX, GDEProc); ccy = UTOP;
    WC = CCreateStatic(hInst, hWnd, UWX, ccy, GWW, 400, UCProc); cy = 0;
    WL = CCreateLabel(hInst, WC, 0, cy, LBW, LBH, tahoma, "   XY:"); cy += STEPL;
    WX = CCreateNumber3D(hInst, WC, 0, cy, ESW, ESH, ID_AX, tahoma); cy += STEP2;
    WL = CCreateLabel(hInst, WC, 0, cy, LBW, LBH, tahoma, "   Z:"); cy += STEPL;
    WZ = CCreateNumber3D(hInst, WC, 0, cy, ESW, ESH, ID_AZ, tahoma); cy += STEP2;
    WL = CCreateLabel(hInst, WC, 0, cy, LBW, LBH, tahoma, " :"); cy += STEPL;
    WP = CCreateNumber3D(hInst, WC, 0, cy, ESW, ESH, ID_VP, tahoma); cy += STEP3;
    WL = CCreateLabel(hInst, WC, 0, cy, LBW, LBH, tahoma, "  X:"); cy += STEPL;
    WLX = CCreateNumber3D(hInst, WC, 0, cy, ESW, ESH, ID_LX, tahoma); cy += STEP2;
    WL = CCreateLabel(hInst, WC, 0, cy, LBW, LBH, tahoma, "  Y:"); cy += STEPL;
    WLY = CCreateNumber3D(hInst, WC, 0, cy, ESW, ESH, ID_LY, tahoma); cy += STEP2;
    WL = CCreateLabel(hInst, WC, 0, cy, LBW, LBH, tahoma, "  Z:"); cy += STEPL;
    WLZ = CCreateNumber3D(hInst, WC, 0, cy, ESW, ESH, ID_LZ, tahoma); cy += STEP3;
    WL = CCreateLabel(hInst, WC, 0, cy, LBW, LBH, tahoma, "Ka  %:"); cy += STEPL;
    WKA = CCreateNumber3D(hInst, WC, 0, cy, ESW, ESH, ID_KA, tahoma); cy += STEP2;
    WL = CCreateLabel(hInst, WC, 0, cy, LBW, LBH, tahoma, "Kd  %:"); cy += STEPL;
    WKD = CCreateNumber3D(hInst, WC, 0, cy, ESW, ESH, ID_KD, tahoma); cy += STEP2;
    WL = CCreateLabel(hInst, WC, 0, cy, LBW, LBH, tahoma, "Ks  %:"); cy += STEPL;
    WKS = CCreateNumber3D(hInst, WC, 0, cy, ESW, ESH, ID_KS, tahoma); cy += STEP2;
    WL = CCreateLabel(hInst, WC, 0, cy, LBW, LBH, tahoma, " :"); cy += STEPL;
    WPH = CCreateNumber3D(hInst, WC, 0, cy, ESW, ESH, ID_PH, tahoma); ccy = UTOP;
    WJ = CCreateStatic(hInst, hWnd, UWX2, ccy, GWW, 100, OBProc); cy = 0;
    WL = CCreateLabel(hInst, WJ, 0, cy, LBW, LBH, tahoma, ":"); cy = STEPL;
    WBX = CCreateRadio3D(hInst, WJ, 0, cy, RSW, RSH, BOX, tahoma, "", 1); cy += STEPE;
    WCL = CCreateRadio3D(hInst, WJ, 0, cy, RSW, RSH, CYL, tahoma, "", 0); cy += STEPE;
    WUS = CCreateRadio3D(hInst, WJ, 0, cy, RSW, RSH, USR, tahoma, "", 0); ccy += 120;
    WR0 = CCreateStatic(hInst, hWnd, UWX2, ccy, GWW, 200, RenderProc); cy = 0;
    WL = CCreateLabel(hInst, WR0, 0, cy, LBW, LBH, tahoma, ":"); cy = STEPL;
    WR1 = CCreateRadio3D(hInst, WR0, 0, cy, RSW, RSH, RE_GOURA, tahoma, "", 1); cy += STEPE;
    WR2 = CCreateRadio3D(hInst, WR0, 0, cy, RSW, RSH, RE_PHONG, tahoma, "", 0); cy += STEP3;
    WED = CCreateCheck3D(hInst, WR0, 0, cy, RSW, RSH, ID_ED, tahoma, " "); cy += STEP3;
    WBG = CCreateCheck3D(hInst, WR0, 0, cy, RSW, RSH, ID_BG, tahoma, " ");
    return TRUE;
}
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow) {
    hInst = hInstance;
    int SW = (GetSystemMetrics(SM_CXSCREEN) - MW) / 2;
    int SH = (GetSystemMetrics(SM_CYSCREEN) - MH) / 2;
    W0 = CreateWindow("RENDER", "Render Primer App", 0x80c80000, SW, SH, MW, MH, 0, 0, hInstance, 0);
    if (!W0) return FALSE;
    ShowWindow(W0, nCmdShow);
    UpdateWindow(W0);
    HDC hdc = GetDC(W0);
    CDC = CreateCompatibleDC(hdc);
    CBMP = CreateCompatibleBitmap(hdc, GDSZ+2, GDSZ+2);
    SelectObject(CDC, CBMP);
    PenB = CreatePen(0, 0, RGB(0, 0, 0));
    PenW = CreatePen(0, 0, RGB(255, 255, 255));
    SelectBackground(blackground);
    PatBlt(CDC, 0, 0, GDSZ+2, GDSZ+2, PATCOPY);
    ReleaseDC(W0, hdc);
    InvalidateRect(W0, 0, 1);
    return CreateControls(hInst, W0);
}
int APIENTRY WinMain(HINSTANCE hInstance, HINSTANCE hPrev, LPTSTR lpCmd, int nCmd) {
    MSG msg;
    int fc = 0;
    if (!RegisterClasses(hInstance)) return FALSE;
    if (!InitInstance(hInstance, nCmd)) return FALSE;
    SetInitials();
    while (GetMessage(&msg, 0, 0, 0)) {
        if (msg.message == WM_KEYUP) {
            if (msg.wParam == KEY_SHIFT) shift_on = 0;
        }
        if (msg.message == WM_KEYDOWN) {
            switch (msg.wParam) {
            case KEY_SHIFT:
                shift_on = 1;
                break;
            case KEY_ESC:
                SendMessage(W0, WM_DESTROY, 0, 0);
                continue;
            case KEY_LEFT:
            case KEY_RIGHT:
                XAngle = GetEditValue(WX);
                if (msg.wParam == KEY_LEFT) {
                    XAngle += D_ANGLE;
                    if (XAngle >= 360) XAngle -= 360;
                } else {
                    XAngle -= D_ANGLE;
                    if (XAngle < 0) XAngle += 360;
                }
                _itoa(XAngle, buf, 10);
                SetWindowText(WX, buf);
                SetFocus(WX);
                SendMessage(WX, EM_SETSEL, 0, -1);
                focused = WX;
                continue;
            case KEY_DOWN:
            case KEY_UP:
                ZAngle = GetEditValue(WZ);
                if (msg.wParam == KEY_DOWN) {
                    ZAngle -= D_ANGLE;
                    if (ZAngle < 0) ZAngle += 360;
                } else {
                    ZAngle += D_ANGLE;
                    if (ZAngle >= 360) ZAngle -= 360;
                }
                _itoa(ZAngle, buf, 10);
                SetWindowText(WZ, buf);
                SetFocus(WZ);
                SendMessage(WZ, EM_SETSEL, 0, -1);
                focused = WZ;
                continue;
            case KEY_TAB:
                fc = focused==WX||focused==WZ||focused==WP||focused==WLX||focused==WLY||focused==WLZ||focused==WKA||focused==WKD||focused==WKS||focused==WPH;
                if (fc) {
                    SetFocus(GetNextDlgTabItem(WC, focused, shift_on));
                } else {
                    SetFocus(WX);
                }
                continue;
            }
        }
        TranslateMessage(&msg);
        DispatchMessageA(&msg);
    }
    return (int)msg.wParam;
}
